# Copy a vector in an other
def copy(G):
    g=[]
    for i in range(0,len(G)):
        g.append(G[i])
    return g

# singularities computation
def sing(E):
    S=[]
    for i in range(0,len(E)-1):
        for j in range(i+1,len(E)):
            s=solve([E[i],E[j]],x,y)
            if s<>[]:
                if not(s[0] in S):    
                    S.append([x==(s[0][0].rhs()),y==(s[0][1].rhs())])                        
    return S

# projection on the axes
def Xprojection(S):
    X=[]
    for i in range(0,len(S)):
        X.append(S[i][0].rhs())
    return X

# projection on real and imaginary part
def Rprojection(S):
    R=[]
    for s in S:
        R.append(real(s))
    return R
    
def Iprojection(S):
    I=[]
    for s in S:
        I.append(imag(s))
    return I
    
# ordering of the projection along x
def sort(R,L):
    S1=[]
    S2=[]
    r=copy(R)
    l=copy(L)
    for i in range(0,len(R)):
        min=0
        for j in range(0,len(r)):
            if r[j]<r[min]:
                min=j
        S1.append(r[min])
        S2.append(l[min])
        del r[min]
        del l[min]
    return S1,S2   

def order(L):
    e=0.000000001
    R=Rprojection(L)
    I=Iprojection(L)
    (I,R)=sort(I,R)    #ordering the y
    (R,I)=sort(R,I)    #ordering the x
    m=[]
    n=[]
    for i in range(0,len(R)-1):
        if abs(R[i]-R[i+1])>e or abs(I[i]-I[i+1])>e:
            m.append(R[i])
            n.append(I[i]) 
    m.append(R[len(R)-1])
    n.append(I[len(I)-1])
    return m,n

# computing of the cloud for the linear interpolation

# founding of the minimum delta between 2 xx
def MIN(xx):
    e=1
    for i in range(0,len(xx)-1):
        if 0<abs(xx[i]-xx[i+1])<e :
            e=abs(xx[i]-xx[i+1])    
    return e/3
    
# creation of the cloud of points
def cloud(xx,xy):
    e=MIN(xx)
    XX=[]
    XY=[]
    for i in range(0,len(xx)):
        XX.append(xx[i]-e)
        XX.append(xx[i]+e)
        XY.append(xy[i])
        XY.append(xy[i])            
    return XX,XY

# linear interpolation of a cloud
def linear_interp(XX,XY,draw=false):
    XX1=[]
    XY1=[]
    XX1.append(XX[0]-15)
    XY1.append(0)
    XX1.append(XX[0]-1)
    XY1.append(0)
    for i in range(0,len(XX)):
        XX1.append(XX[i])
        XY1.append(XY[i])
    XX1.append(XX[len(XX)-1]+1)
    XY1.append(0)
    XX1.append(XX[len(XX)-1]+1+15)
    XY1.append(0)
    C=[]
    p=[]
    for i in range(0,len(XX1)-1):
        f(t)=XY1[i]+(t-XX1[i])*(XY1[i+1]-XY1[i])/(XX1[i+1]-XX1[i])
        if XX1[i]-XX1[i+1]<0:
            C.append([f(t),XX1[i],XX1[i+1],1])
            p.append(plot(f,(XX1[i],XX1[i+1]))) 
        else :  
            C.append([f(t),XX1[i+1],XX1[i],-1])
            p.append(plot(f,XX1[i+1],(XX1[i])))
    if draw:                 
        P=p[0]
        for i in range(1,len(p)):
            P=P+p[i]
        show(P)
    return C

# Computation of the lifts of C
def lift(A,C,draw=false):
    T=[]
    W=[]
    for j in range(0,len(C)):
        
        # lifting of the paths
        T.append([])
        for k in range(0,len(A)):
            Ak=A[k].lhs()
            Ak=Ak.subs(x=t+I*C[j][0])
            Sol=solve(Ak,y)
            if not(Sol==[]):
                T[j].append(Sol[0])
        
        # projection of the lift on the real part
        W.append([])
        for i in range(len(T[j])):
            W[j].append(real(T[j][i].rhs()))
            
        # displaying the Wiring diagram
        if draw :
            var('d')
            d=plot([x],[1,-1])
            #s(t)=W[j][0]
            #d=plot([s(t)],[C[j][1],C[j][2]],rgbcolor=hue(0.1))            
            for i in range(len(W[j])):
                s(t)=W[j][i]
                if j==0:        
                    d=d+plot([s(t)],[C[j][1],C[j][2]],rgbcolor=hue(i*0.1+0.1), legend_label=str(i))
                else:
                    d=d+plot([s(t)],[C[j][1],C[j][2]],rgbcolor=hue(i*0.1+0.1))                                    
            if j==0:
                D=d
            else :
                D=D+d
    if draw :
        show(D,axes=false)
    return (T,W)

# Founding the order of the lines at the beginning of the phase m
def position(W,m,C):
    P=[]
    for k in range(len(W)):
        if C[m][3]==1:
            P.append(W[k].subs(t=C[m][1]))
        else:
            P.append(W[k].subs(t=C[m][2]))
    L=range(len(P))
    (P,L)=sort(P,L)
    return L

# Founding the cross type
def found_cross(m,A,T,W,C,e):
    print('Phase : '+str(m)+'/'+str(len(W)-1))
    wd=[]
    for i in range(0,len(W[m])-1):
        for j in range(i+1,len(W[m])):
            s1(t)=W[m][i]
            s2(t)=W[m][j]
            SOL=solve([s1==s2],t)
            for k in SOL :
                K=(k.rhs())
                if (C[m][1]<=K) and (K<=C[m][2]):
                    r1(t)=T[m][i].rhs()
                    r2(t)=T[m][j].rhs()           
                    h1=imag(r1(K))           
                    h2=imag(r2(K))
                    if h1>h2+e :
                        wd.append([K.n(20),(i,-1),(j,1),abs(h1-h2).n(10)])
                    else :
                        if h1<h2-e :
                            wd.append([K.n(20),(i,1),(j,-1),abs(h1-h2).n(10)])
                        else :
                            wd.append([K.n(20),(i,0),(j,0),abs(h1-h2).n(10)])   
    return wd

# Split the cross in different parts.
def split(W):
    G=Graph()        
    for i in range(0,len(W)):
        for j in range(0,len(W[i])-1):
            G.add_edge([W[i][1][0],W[i][j+1][0]])
    CC=G.connected_components()
    S=[]
    for i in range(0,len(CC)):
        S.append([])
    for i in range(0,len(W)):
        test=false
        j=0
        while j<len(CC) and not(test):
            if W[i][1][0] in CC[j]:
                S[j].append(W[i])
                test=true
            else:
                j=j+1
    return S

# Permute the position P in function of the cross of SW
def cross(P,SW):
    p=copy(P)
    cp=len(P)
    for i in range(0,len(P)):
        test=false
        j=1
        while not(test) and j<len(SW):
            if SW[j][0]==P[i]:
                test=true
                if j<cp:
                    cp=j
            else:
                j=j+1
    for i in range(0,len(SW)-1):
        p[cp+i]=P[cp+len(SW)-i-2]
    return p

# Reorder SW in function of P for obtained a drawable diagram
def reorder(SW,P):
    sw=[]
    SW1=copy(SW)
    for i in range(0,len(P)-1):
        for j in range(i+1,len(P)):
            (C,SW1)=found(P[i],P[j],SW1)
            if C<>[]:
                sw.append(C)
    return(sw)

# Found in SW1 the cross containing P1 and P2
def found(P1,P2,SW1):
    i=0
    C=[]
    SW=copy(SW1)
    test=false
    while i<=len(SW)-1 and not(test):
        if (((P1,1) in SW[i]) or ((P1,-1) in SW[i]) or ((P1,0) in SW[i])) and (((P2,1) in SW[i]) or ((P2,-1) in SW[i]) or ((P2,0) in SW[i])):
            C=SW[i]
            del SW[i]
            test=true
        i=i+1
    return(C,SW)

# Reorganise the Wiring diagram in function of P on an interval
def agencement(WD,P):
    i=0
    e=0.00001    
    while i<len(WD):
        j=i
        W=[]
        ind=[]
        P1=copy(P)
        while j<=len(WD)-1 and abs(WD[i][0]-WD[j][0])<e:              
            ind.append(j)
            W.append(WD[j])
            j=j+1      
        SW=split(W)
        l=len(ind)
        for j in range(0,len(SW)):
            SW1=reorder(SW[j],P)
            for k in range(0,len(SW1)):
                WD[ind[0]]=SW1[k]
                P1=cross(P1,SW1[k])
                del ind[0]
        P=P1                
        if l==0:
            i=i+1
        else :
           i=i+l 
    return WD

# Founding the explicite Wiring diagram
def Wiring(A,T,W,C,draw):
    e=0.00001
    WD=[]

    # Founding the cross type
    for m in range(0,len(C)):
        wd=found_cross(m,A,T,W,C,e)

        # ordering the cross        
        WD.append([])
        if C[m][3]==1:
            for k in range(0,len(wd)):
                mini=wd[0][0]
                l=0
                for i in range(1,len(wd)):
                    if wd[i][0]<=mini :
                        l=i
                        mini=wd[i][0]
                WD[m].append(wd[l])
                del wd[l]
        else:
            for k in range(0,len(wd)):
                maxi=wd[0][0]
                l=0
                for i in range(0,len(wd)):
                    if wd[i][0]>=maxi :
                        l=i
                        maxi=wd[i][0]
                WD[m].append(wd[l])
                del wd[l] 
                
        # ordonning the virtual to obtained something of drawable
        #WD[m]=agencement(WD[m],position(A,m,C))
        
        # contraction of the informations about multiple point
 
                                                                                                        
    
    # concatenation of the information    
    diagram=[]
    for i in range(0,len(WD)):
        diagram=diagram+WD[i]

    return diagram

# Printing with a good presentation the result
def display(W):
    for i in range(0,len(W)):
        print(W[i])

# Global function giving the Wiring diagram with enter the equations of A
def Wiring_diagram(A,draw=false):
    S=sing(A)
    L=Xprojection(S)
    (xx,xy)=order(L)
    (XX,XY)=cloud(xx,xy)   
    var('t')
    C=linear_interp(XX,XY,draw)
    P=position(A,0,C)
    (T,W)=lift(A,C,draw)
    diagram=Wiring(A,T,W,C,draw)
    #diagram=convert(diagram)
    if draw:
        print(P)
        display(diagram)
    return (diagram,P)
    
##########################################################################
###### Attention  mettre les quations sous la forme f(x,y)=0 !! ########
##########################################################################